//
// = FILENAME
//    PRMNode.cc
//
// = AUTHOR(S)
//    Patric Jensfelt
//
/*----------------------------------------------------------------------*/

#include "PRMNode.h"

#include <cmath>
#include <algorithm>

void
PRMNode::addNewEdge(PRMNode *node)
{
  m_Edges.push_back(node);
}

void
PRMNode::deleteEdge(PRMNode *node)
{
  std::list<PRMNode*>::iterator foundEdge = m_Edges.end();

  foundEdge = std::find(m_Edges.begin(), m_Edges.end(), node);
  
  if (foundEdge != m_Edges.end()) m_Edges.erase(foundEdge);
}

bool
PRMNode::getConnections(std::list< std::pair<AStarNode*, double> > &l)
{
  int j;
  double dis=0, *tempa=geta(), dt, *tempi;
  for (std::list<PRMNode*>::iterator i = m_Edges.begin();
       i != m_Edges.end(); i++) {
    tempi = (*i)->geta();
    for(j=0;j<n_arms;j++) {
      dt = tempa[j] - tempi[j];
      if(dt < -180.0)
	dt=dt+360.0;
      else if (dt > 180.0)
	dt=dt-360.0;
      dis += dt*dt;
    }
    dis = sqrt(dis);
    l.push_back( std::make_pair(*i, dis) );
  }
  return true;
}
