//
// = FILENAME
//    Position.hh
//
// = AUTHOR(S)
//    Patric Jensfelt
//
/*----------------------------------------------------------------------*/

#ifndef Position_hh
#define Position_hh
/**
 * This class encapsulates position data
 */
class Position {
public:
  /// Empty constructor
  Position();

  /// Constructor that allows you to set the position (x,y)
  Position(int n, double a[]);

  /// Function used to copy an object
  Position(const Position &src);

  /// Function used to copy an object
  void operator=(const Position &src);

  /// Function to set the x-coordinate of the position
  void setn(int n);

  /// Function to get the x-coordinate of the position
  int getn() const;

  /// Function to set the x-coordinate of the position
  void seta(double arms[]);

  /// Function to get the x-coordinate of the position
  double *geta();

public:
  int n_arms;
  double angles[15];
};
inline void Position::setn(int n) { n_arms = n; }
inline int   Position::getn() const { return n_arms; }
inline void Position::seta(double arms[]) { int i;for(i=0;i<n_arms;i++,angles[i]=arms[i]);}
inline double* Position::geta() { return angles; }

#endif // Position_hh
