#include "dialog.h"
#include "ui_dialog.h"
#include <vector>
#include "Planner.h"
#include <math.h>

///////////////////////////////////////////////////////////////////
Dialog::Dialog(QWidget *parent) :
  QDialog(parent),
  ui(new Ui::Dialog)
{
  ui->setupUi(this);
  scene = new myScene (this);
  ui->graphicsView->setScene(scene);

  scene->setSceneRect(0,0,300,300);
  //
  item = new MyItem();
  //item->setTransformOriginPoint(150,150);
  //item->setFlag(QGraphicsItem::ItemIsMovable);
  //    graphicsItem->setTransform(QTransform().translate(centerX, centerY).rotate(angle).translate(-centerX, -centerY));
  scene->addItem(item);

  no_arms = 0;
  QPen mypen = QPen(Qt::red);
  mypen.setWidth(2);

  //QLineF TopLine(scene->sceneRect().topLeft(), scene->sceneRect().topRight());
  //QLineF LeftLine(scene->sceneRect().topLeft(), scene->sceneRect().bottomLeft());
  //QLineF RightLine(scene->sceneRect().topRight(), scene->sceneRect().bottomRight());
  //QLineF BottomLine(scene->sceneRect().bottomLeft(), scene->sceneRect().bottomRight());

  //scene->addLine(TopLine,mypen);
  //scene->addLine(LeftLine,mypen);
  //scene->addLine(RightLine,mypen);
  //scene->addLine(BottomLine,mypen);

  colors.push_back("blue");
  colors.push_back("yellow");
  colors.push_back("red");
  colors.push_back("green");
  colors.push_back("blue");

  timer = new QTimer(this);
  ui->run->setEnabled(false);
  //connect(timer,SIGNAL(timeout()),scene,SLOT(drawRobot(trace)));
  //timer->start(100);
  //scene2= new myScene(this);
  //ui->graphicsView->setScene(scene2);
  //scene2->setSceneRect(0,0,300,300);

  index=-1;

}

Dialog::~Dialog()
{
  delete ui;
}

void Dialog::toggleButtons(bool enab)
{
  ui->addObstacle->setEnabled(enab);
  ui->doneObstacle->setEnabled(enab);
  ui->addRobot->setEnabled(enab);
  ui->doneRobot->setEnabled(enab);
  //ui->startPoint->setEnabled(enab);
  //ui->startPointDone->setEnabled(enab);
  //ui->endPoint->setEnabled(enab);
  //ui->endPointDone->setEnabled(enab);
  ui->run->setEnabled(enab);
}

void Dialog::on_addObstacle_clicked()
{
  scene->setPolyPressed();
  toggleButtons(false);
  ui->doneObstacle->setEnabled(true);

}

void Dialog::on_doneObstacle_clicked()
{
  scene->polyDone();
  toggleButtons(true);
}

void Dialog::on_addRobot_clicked()
{
  scene->setLinePressed();
  toggleButtons(false);
  ui->doneRobot->setEnabled(true);
}

void Dialog::on_doneRobot_clicked()
{
  toggleButtons(true);
  scene->linePressed = false;
}

/*void Dialog::on_startPoint_clicked()
{
  scene->startPressed = true;
  toggleButtons(false);
  ui->startPointDone->setEnabled(true);
}*/

/*void Dialog::on_startPointDone_clicked()
{
  scene->startPressed = false;
  toggleButtons(true);
}*/

/*void Dialog::on_endPoint_clicked()
{
  toggleButtons(false);
  ui->endPointDone->setEnabled(true);
  scene->endPressed = true;
}*/

/*void Dialog::on_endPointDone_clicked()
{
  toggleButtons(true);
  scene->endPressed = false;
}*/

void Dialog::on_run_clicked()
{
  unsigned i, j, id=0;
  double obstlx1[MAX_OBSL], obstlx2[MAX_OBSL], obstly1[MAX_OBSL], obstly2[MAX_OBSL], no_arm, lengths[MAX_ARMS];
  for(i=0;i<scene->Obstacles.size();i++)
    {
      unsigned tom = scene->Obstacles[i].size();
      for(j=0;j<tom;j++,id++)
	{
	  obstlx1[id]=scene->Obstacles[i][j].first-150;
	  obstly1[id]=scene->Obstacles[i][j].second-150;
	  obstlx2[id]=scene->Obstacles[i][(j+1)%tom].first-150;
	  obstly2[id]=scene->Obstacles[i][(j+1)%tom].second-150;
	}
    }
  no_arm = scene->Robot.size()-1;
  for(i=0;i<scene->Robot.size();i++)
    {
      lengths[i]=sqrt((scene->Robot[i+1].first - scene->Robot[i].first)*(scene->Robot[i+1].first - scene->Robot[i].first) +
		      (scene->Robot[i+1].second - scene->Robot[i].second)*(scene->Robot[i+1].second - scene->Robot[i].second));
    }
  double start[MAX_ARMS]={0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
  double end[MAX_ARMS]={180, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
  QString fileName = "config";  
  QFile file(fileName);
  ui->next->setDisabled(false);
  ui->pushButton->setDisabled(true);
  if (!file.open(QIODevice::ReadOnly)) {
    QMessageBox::information(this, tr("Unable to open config file:\n Using default values\n"), file.errorString());
  }
  else {
    QTextStream in(&file);    
    QStringList stringList;
    for(int i=0;i<no_arm;i++){
      QString line = in.readLine();      
      stringList = line.split("\t");
      if (line.isNull()) {
	break;
      }
      if(!stringList.isEmpty())
	{
	  start[i] = stringList.at(0).toDouble();
	  end[i] =   stringList.at(1).toDouble();
	}
      else 
	{
	  break;
	}
    }
  }
  Planner *plan = new Planner(no_arm, lengths, .1, id, obstlx1, obstly1, obstlx2, obstly2, start, end);
  configurations = plan->main1(0,NULL);
  qDebug()<<"Found "<<configurations.size()<<"configurations\n";
  
}


void Dialog::drawRobot(std::vector<std::pair<int,int> > trace)
{
  // std::string col = colors.back();
  // colors.pop_back();
  QPen blackPen(Qt::blue);
  blackPen.setWidth(1);
  for(int i=0;i<trace.size()-1;i++)
    {
      scene->addLine(trace[i].first, trace[i].second, trace[i+1].first, trace[i+1].second, blackPen);
      scene->drawPoint(trace[i].first,trace[i].second);
      scene->drawPoint(trace[i+1].first,trace[i+1].second);
    }
}
void Dialog::drawObstacle(std::vector<std::pair<int,int> > trace)
{
  // std::string col = colors.back();
  // colors.pop_back();
  int tom=trace.size();
  QPen blackPen(Qt::green);
  blackPen.setWidth(1);
  for(int i=0;i<trace.size();i++)
    {
      scene->addLine(trace[i].first,trace[i].second, trace[(i+1)%tom].first, trace[(i+1)%tom].second,blackPen);
      scene->drawPoint(trace[i].first, trace[i].second);
      //scene->drawPoint(trace[(i+1)%tom].first, trace[(i+1)%tom].second);
    }
}
void Dialog::drawObstacles(std::vector<std::vector<std::pair<int,int> > > obstacles)
{
  for(int i=0;i<obstacles.size();i++) {
    drawObstacle(obstacles[i]);
  }   
}
void Dialog::drawConfig(int index)
{
  if(index < 0 || index >= configurations.size())
    {
      return;
    }
  std::vector <std::pair <int, int > > temp = configurations[index];
  no_arms = scene->Robot.size()-1;
  //std::string col = colors.back();
  //colors.pop_back();
  QPen blackPen(Qt::gray);
  blackPen.setWidth(1);
  for(int j=0;j<no_arms;j++){
    scene->addLine(temp[j].first, temp[j].second, temp[j+1].first, temp[j+1].second, blackPen);
    scene->drawPoint(temp[j].first, temp[j].second);
    scene->drawPoint(temp[j+1].first, temp[j+1].second);
  }
}


void Dialog::on_saveToFile_clicked()
{
  QString fileName = QFileDialog::getSaveFileName(this, tr("Save Configurations"), "", tr(""));
  if (fileName.isEmpty())
    return;
  else {
    QFile file(fileName);
    if (!file.open(QIODevice::WriteOnly)) {
      QMessageBox::information(this, tr("Unable to open file"),
			       file.errorString());
      return;
    }
    QTextStream out(&file);
    //out.setVersion(QDataStream::Qt_4_5);
    float x,y;
    for(int i=0;i<scene->Robot.size();i++)
      {
	x= scene->Robot[i].first;
	y=scene->Robot[i].second;
	//qDebug()<<x<<y;
	out << float(x) << "," << float(y)<<"\n";

      }
    out<<"Robot\n";
    for(int i=0;i<scene->Obstacles.size();i++)
      {
	for(int j=0;j<scene->Obstacles[i].size();j++)
	  {

	    x= scene->Obstacles[i][j].first;
	    y=scene->Obstacles[i][j].second;
	    //qDebug()<<x<<y;
	    out << float(x) << "," << float(y)<<"\n";

	  }
	out << "Obstacle\n";
      }
    for(int i=0;i<configurations.size();i++)
      {
	for(int j=0;j<configurations[i].size();j++)
	  {
	    x= configurations[i][j].first;
	    y= configurations[i][j].second;
	    //qDebug()<<x<<y;
	    out << float(x) << "," << float(y)<<"\n";
	  }
	out << "Configurations\n";
      }
    //   out<< "\n";
  }
}

void Dialog::refresh_screen(bool ifdrawObstacle, bool ifdrawRobot)
{
  scene->clear();
  if(ifdrawRobot) {
     drawRobot(scene->Robot);
  }
  if(ifdrawObstacle) {
    drawObstacles(scene->Obstacles);
  }
  scene->drawPoint(150,150);
}

void Dialog::on_pushButton_2_clicked()
{
  ui->run->setEnabled(true);
  QString fileName = QFileDialog::getOpenFileName(this,
						  tr("Open Configuration File"), "",
						  tr(""));
  if (fileName.isEmpty())
    return;
  else {	 
    QFile file(fileName);

    if (!file.open(QIODevice::ReadOnly)) {
      QMessageBox::information(this, tr("Unable to open file"),
			       file.errorString());
      return;
    }
 
    QStringList stringList;
    QTextStream in(&file);
    trace.clear();
    config.clear();
    scene->Robot.clear();
    scene->Obstacles.clear();
    configurations.clear();
    scene->clear();
    index =-1; 
    ui->next->setDisabled(false);
    ui->pushButton->setDisabled(true);
    refresh_screen(false, false);
    while (true)
      {
	QString line = in.readLine();
	stringList = line.split(",");
	if (line.isNull()) {
	  break;
	}
	else
	  {
	    if(line == "Robot"){
	      qDebug()<<"Robot";
	      for(int i=0;i<trace.size();i++)
		{
		  scene->Robot.push_back(std::make_pair(trace[i].first,trace[i].second));
		}
	      drawRobot(scene->Robot);
	      trace.clear();
	    }
	    else if(line=="Obstacle"){
	      qDebug()<<"Obstacle";
	      for(int i=0;i<trace.size();i++)
		{
		  scene->Obstacle.push_back(std::make_pair(trace[i].first,trace[i].second));
		}
	      drawObstacle(scene->Obstacle);
	      scene->Obstacles.push_back(scene->Obstacle);
	      trace.clear();
	      scene->Obstacle.clear();
	    }
	    else if(line=="Configurations"){
	      qDebug()<<"Configurations";
	      for(int i=0;i<trace.size();i++)
		{
		  config.push_back(std::make_pair(trace[i].first, trace[i].second));
		}
	      configurations.push_back(config);
	      trace.clear();
	      config.clear();
	    }
	    else {
	      qDebug()<<stringList;
	      if(!stringList.isEmpty())
		{
		  trace.push_back(std::make_pair(stringList.at(0).toInt(),stringList.at(1).toInt()));
		}
	    }
	  }
      }
  }
}






void Dialog::on_rotateMinus_clicked()
{
  //item->setRotation(-5);
  //// item->setTransform(QTransform().translate(150,150).rotate(10).translate(-150,-150));
  //item->update();
  qDebug()<<"rotate -5";
  //scene->update();
  //scene->clear();

}

void Dialog::on_rotatePlus_clicked()
{
  //item->setRotation(5);
  // item->setTransform(QTransform().translate(150,150).rotate(-10).translate(-150,-150));
  //item->update();
  qDebug()<<"rotate +5";
  //ui->graphicsView->setScene(scene);
}



void Dialog::on_next_clicked()
{
    qDebug()<<index+1<<"/"<<configurations.size();
    // if(index >= (configurations.size()-2))
    //   {
    // 	ui->next->setDisabled(true);
    //   }
    if(index == configurations.size()-1) {
      return;
    }
    index++;
    if(index < configurations.size()) {
      // refresh_screen(true, false);
      if(index > 0) {
        drawConfig(index-1);
      }
      drawConfig(index);
    }
    if(index >= 0 && index <= configurations.size())
      {
	ui->pushButton->setDisabled(false);
      }
}

void Dialog::on_pushButton_clicked()
{
  qDebug()<<index-1<<"/"<<configurations.size();
  if(index <= 0)
    {
      ui->pushButton->setDisabled(true);
    }
  if(index == -1) {
    return ;
  }
  index--;
  if(index == -1)
    {
      refresh_screen(true, true);
      return;
    }
  if(index >= 0 ) {
    refresh_screen(true, false);
    if(index < configurations.size()-1) {
      drawConfig(index+1);
    }
    drawConfig(index);
  }
  if(index >= -1 && index < configurations.size()-1)
    {
      ui->next->setDisabled(false);
    }
}


void Dialog::on_Clear_clicked()
{
  refresh_screen(false,false);
    scene->Obstacles.clear();
    scene->Robot.clear();
    scene->Obstacle.clear();
    configurations.clear();
    trace.clear();
    ui->pushButton->setDisabled(true);

}
