#ifndef DIALOG_H
#define DIALOG_H

#include <QDialog>
#include <QtCore>
#include <QtGui>
#include <vector>
#include <string>
#include "myscene.h"
#include "myitem.h"

namespace Ui {
class Dialog;
}


////////////////////////////////////////////////
class Dialog : public QDialog
{
    Q_OBJECT
    
public:
    explicit Dialog(QWidget *parent = 0);
    ~Dialog();
    void toggleButtons(bool enab);
    void drawObstacle(std::vector<std::pair<int,int> > obstacle);
    void drawObstacles(std::vector<std::vector<std::pair<int,int> > > obstacles);
    void drawRobot(std::vector<std::pair<int,int> > robot);
    void drawConfig(int index);

    std::vector<std::string> colors;
    std::vector<std::pair<int,int > > trace;
    std::vector<std::vector<std::pair<int,int> > > configurations;
    std::vector<std::vector<std::pair<int, int> > > obstacles;
    std::vector<std::pair<double, double> > robot;
    std::vector<std::pair<int,int> >  config;
    //std::vector<std::pair<int,int > > config;
    int no_arms;
    int index;


    
private slots:
    void on_addObstacle_clicked();

    void on_doneObstacle_clicked();

    void on_addRobot_clicked();

    void on_doneRobot_clicked();

   // void on_startPoint_clicked();

    //void on_startPointDone_clicked();

    //void on_endPoint_clicked();

    //void on_endPointDone_clicked();

    void on_run_clicked();


    //void on_pushButton_clicked();
   // void loadFromFile();

    void on_saveToFile_clicked();

    void on_pushButton_2_clicked();


    void on_next_clicked();

    //void on_previous_clicked();

    void on_rotateMinus_clicked();

    void on_rotatePlus_clicked();

    void refresh_screen(bool ifdrawObstacle, bool ifdrawRobot);



    void on_pushButton_clicked();

    void on_Clear_clicked();

private:
    Ui::Dialog *ui;
    myScene *scene;
   // myScene *scene2;
    QTimer * timer;
    MyItem *item;
    //QPushButton *exit;

};

#endif // DIALOG_H
