#include "myscene.h"
#include "dialog.h"
#include "ui_dialog.h"
#include <vector>
#include "Planner.h"
#include <math.h>

myScene::myScene(QDialog *parent) :
    QGraphicsScene(parent)
{
    lastpoint.setX(150);
    lastpoint.setY(150);
    Robot.push_back(std::make_pair(150,150));
    linePressed = false;
    polyPressed = false;
    startPressed = false;
    endPressed = false;

    lastPolyPoint.setX(-1);
    lastPolyPoint.setY(-1);
    drawPoint(150,150);
}

myScene::~myScene()
{

}

void myScene::mousePressEvent(QGraphicsSceneMouseEvent *event)
{
   // qDebug()<< "Line pressed "<<linePressed<<" Polypressed "<<polyPressed;
    if(linePressed)
    {

        drawLine(lastpoint.x(),lastpoint.y(),event->scenePos().x(),event->scenePos().y());
        lastpoint.setX(event->scenePos().x());
        lastpoint.setY(event->scenePos().y());

        Robot.push_back(std::make_pair(event->scenePos().x(),event->scenePos().y()));
    }
    else if(polyPressed)
    {
        if(lastPolyPoint.x()==-1 && lastPolyPoint.y()==-1)
        {
            drawPoint(event->scenePos().x(),event->scenePos().y());
            lastPolyPoint.setX(event->scenePos().x());
            lastPolyPoint.setY(event->scenePos().y());
            firstPolyPoint.setX(event->scenePos().x());
            firstPolyPoint.setY(event->scenePos().y());


            Obstacle.clear();
            Obstacle.push_back(std::make_pair(event->scenePos().x(),event->scenePos().y()));
        }
        else
        {
            drawLine(lastPolyPoint.x(),lastPolyPoint.y(),event->scenePos().x(),event->scenePos().y());
            lastPolyPoint.setX(event->scenePos().x());
            lastPolyPoint.setY(event->scenePos().y());
            Obstacle.push_back(std::make_pair(event->scenePos().x(),event->scenePos().y()));
        }
    }
    else if(startPressed)
    {
        startPoint = std::make_pair(event->scenePos().x(),event->scenePos().y());
        QPen pen(Qt::red);
        QBrush brush(Qt::red);
        addRect(event->scenePos().x(),event->scenePos().y(),2,2,pen,brush);
    }
    else if(endPressed)
    {
        endPoint = std::make_pair(event->scenePos().x(),event->scenePos().y());
        QPen pen(Qt::green);
        QBrush brush(Qt::green);
        addRect(event->scenePos().x(),event->scenePos().y(),2,2,pen,brush);
    }
}

void myScene::setPolyPressed()
{
    polyPressed=true;
    linePressed=false;
}

void myScene::setLinePressed()
{
    linePressed=true;
    polyPressed=false;
}

void myScene::drawLine(int x1, int y1, int x2, int y2)
{
    QPen blackPen;

    if(polyPressed)
    {
        blackPen.setColor(Qt::red);
    }else blackPen.setColor(Qt::blue);


    blackPen.setWidth(1);
    addLine(x1,y1,x2,y2,blackPen);
    drawPoint(x1,y1);
    drawPoint(x2,y2);

}
void myScene::drawPoint(int x1, int y1)
{
    QPen pen(Qt::black);
    pen.setWidth(1);
    QBrush brush(Qt::black);
    addRect(x1,y1,2,2,pen,brush);

}

void myScene::polyDone()
{
    polyPressed = false;
    if(!(lastPolyPoint.x()==-1 && lastPolyPoint.y()==-1))
    {
        drawLine(lastPolyPoint.x(),lastPolyPoint.y(),firstPolyPoint.x(),firstPolyPoint.y());
        lastPolyPoint.setX(-1);
        lastPolyPoint.setY(-1);
        if(!Obstacle.empty())
            Obstacles.push_back(Obstacle);
    }

}

